#ifndef CLASS_DEFINE
struct unix_user
{
  struct lsh_object super;
  uid_t uid;
  gid_t gid;
  struct lsh_string *name;
  struct lsh_string *passwd;
  struct lsh_string *home;
  struct lsh_string *shell;
};
extern struct lsh_class unix_user_class;
#endif /* !CLASS_DEFINE */

#ifndef CLASS_DECLARE
static void do_unix_user_free(struct lsh_object *o)
{
  struct unix_user *i = (struct unix_user *) o;
  lsh_string_free(i->name);
  lsh_string_free(i->passwd);
  lsh_string_free(i->home);
  lsh_string_free(i->shell);
}

struct lsh_class unix_user_class =
{ STATIC_HEADER,
  0, "unix_user", sizeof(struct unix_user),
  NULL,
  do_unix_user_free
};
#endif /* !CLASS_DECLARE */

#ifndef CLASS_DEFINE
struct unix_service
{
  struct lsh_object super;
  struct ssh_service *(*(login))(struct unix_service *self, struct unix_user *user);
};
extern struct lsh_class unix_service_class;
#endif /* !CLASS_DEFINE */

#ifndef CLASS_DECLARE
struct lsh_class unix_service_class =
{ STATIC_HEADER,
  0, "unix_service", sizeof(struct unix_service),
  NULL,
  NULL
};
#endif /* !CLASS_DECLARE */

