#ifndef CLASS_DEFINE
struct read_packet
{
  struct read_handler super;
  int state;
  UINT32 sequence_number;
  UINT32 pos;
  struct lsh_string *buffer;
  UINT8 * crypt_pos;
  struct lsh_string *received_mac;
  struct abstract_write *handler;
  struct ssh_connection *connection;
};
extern struct lsh_class read_packet_class;
#endif /* !CLASS_DEFINE */

#ifndef CLASS_DECLARE
static void do_read_packet_mark(struct lsh_object *o, 
void (*mark)(struct lsh_object *o))
{
  struct read_packet *i = (struct read_packet *) o;
  mark((struct lsh_object *) i->handler);
  mark((struct lsh_object *) i->connection);
}

static void do_read_packet_free(struct lsh_object *o)
{
  struct read_packet *i = (struct read_packet *) o;
  lsh_string_free(i->buffer);
  lsh_string_free(i->received_mac);
}

struct lsh_class read_packet_class =
{ STATIC_HEADER,
  &read_handler_class, "read_packet", sizeof(struct read_packet),
  do_read_packet_mark,
  do_read_packet_free
};
#endif /* !CLASS_DECLARE */

